/**********************************************************************/
/* Copywrite Edscott Wilson Garcia 2005-2010 
 * See attached GPL licence for further information.
 * 
 * ********************************************************************/

#define RFM_DESKVIEW_C
#include "rodent_libs.h"
#include "deskview.h"

static view_t *deskview_pointer;


/* static code */

#include "deskview_desktop.i"
#include "deskview_callbacks.i"
#include "deskview_main.i"
#include "deskview_monitor.i"

/* exportable symbols: */

G_MODULE_EXPORT GtkWidget *
create_desktop ( void) {
    view_t *view_p;
    record_entry_t *en;
    gchar *deskdir = NULL;
    int i;

    for(i = 0; i < rfm_global_p->argc; i++) {
        if(strcmp ("--id", rfm_global_p->argv[i]) == 0 || strcmp ("-id", rfm_global_p->argv[i]) == 0) {
            if(!rodent_running ())
                g_warning ("%s not running", rfm_global_p->argv[0]);
            exit (0);
        }
    }

    desktop_main ();

    if(getenv ("RFM_DESKTOP_DIR") && strlen (getenv ("RFM_DESKTOP_DIR"))) {
        deskdir = g_strdup (getenv ("RFM_DESKTOP_DIR"));
        if(!g_file_test (deskdir, G_FILE_TEST_EXISTS)) {
            g_free (deskdir);
            deskdir = NULL;
        }

    }
    if(!deskdir) {
        deskdir = g_build_filename (g_get_home_dir (), _("Desktop"), NULL);
    }

    if (!g_file_test(deskdir, G_FILE_TEST_IS_DIR)){
	DBG("Creating desktop dir: %s",deskdir);
	g_mkdir_with_parents (deskdir, 0700);
	if (!g_file_test(deskdir, G_FILE_TEST_IS_DIR)){
	    g_warning ("Desktop directory does not exist: %s", deskdir);
	    exit (1);
	}
    }
    en = rfm_stat_entry (deskdir, __LOCAL_TYPE | __ROOT_TYPE);
    if(!en) {
        g_warning ("en==NULL");
        return NULL;
    }
    deskview_pointer = view_p = create_deskview ();
    g_thread_create(rodent_create_popup_bythread, (gpointer)view_p, FALSE, NULL);

    rodent_add_view (view_p);

    rodent_full_reload_view ((gpointer) view_p, en);

    rodent_monitor ((gpointer) g_thread_self ());
    g_timeout_add (160, (GtkFunction) watch_root, view_p);
    return view_p->widgets.window;
}

