#define TIMERVAL 1000
#define MAX_LOAD_TIME 2

static gboolean
watch_root (
    gpointer data
) {
    view_t *view_p = (view_t *) data;
    static gchar *desktop_color = NULL;
    static gchar *desktop_bg_file = NULL;
    gboolean reload = FALSE;
    gboolean regen_background = FALSE;

    if (!view_p->desktop_dir || strlen(view_p->desktop_dir)==0 || view_p->desktop_dir[0]!='/'){
	return TRUE;
    }
    TRACE("watch_root: view_p->protected=%d\n",view_p->protected);
    if (view_p->protected) {
	DBG("monitor found protected condition\n");
	return TRUE;
    }
    TRACE ("DESK: watch_root\n");
    /* this is necesary when wm is twm... maybe others as well, but will dunk under nautilus desktop if running... */
// FIXME: only for twm? maybe fvwm too?
    //XLowerWindow(GDK_DISPLAY(),GDK_WINDOW_XID(((GtkWidget *)view_p->widgets.window)->window));

    if(getenv ("RFM_NAVIGATE_DESKTOP")
       && strlen (getenv ("RFM_NAVIGATE_DESKTOP"))) {
        view_p->child_constructor = NULL;
    } else {
        view_p->child_constructor = child_constructor;
    }
#if 10
    if(getenv ("RFM_DESKTOP_DIR") && strlen (getenv ("RFM_DESKTOP_DIR"))) {
        if(!view_p->desktop_dir)
            view_p->desktop_dir = g_strdup (getenv ("RFM_DESKTOP_DIR"));
        if(strcmp (getenv ("RFM_DESKTOP_DIR"), view_p->desktop_dir) && g_file_test (getenv ("RFM_DESKTOP_DIR"), G_FILE_TEST_IS_DIR)
            ) {
            DBG ("DESKo: watch_root RFM_DESKTOP_DIR =%s != %s (desktop_fir)\n", getenv ("RFM_DESKTOP_DIR"), view_p->desktop_dir);
#if 10
            /*    
             *    this is a hard reload: directory has changed!.
             *    */
             record_entry_t *en;
             en = rfm_stat_entry(getenv("RFM_DESKTOP_DIR"), __LOCAL_TYPE | __ROOT_TYPE);
             if (rodent_refresh(&(view_p->widgets), en)) {
		 DBG("rodent desk-monitor hard refresh done!\n");
                 // reload did not fail 
                 g_free (view_p->desktop_dir);
                 view_p->desktop_dir = g_strdup (getenv ("RFM_DESKTOP_DIR"));
             } else {
                 //reload failed (view_p->protected was found)
                 //so we will try again in next timeout
             }
#endif
            DBG ("DESK: watch_root RFM_DESKTOP_DIR returns\n");
            return TRUE;
        }
    }
#endif
    if(getenv ("RFM_DESKTOP_COLOR") && strlen (getenv ("RFM_DESKTOP_COLOR"))) {
        if(!desktop_color || strcmp (desktop_color, getenv ("RFM_DESKTOP_COLOR"))) {
            DBG ("DESK: watch_root now reloading RFM_DESKTOP_COLOR %s\n", getenv ("RFM_DESKTOP_COLOR"));
            g_free (desktop_color);
            desktop_color = g_strdup (getenv ("RFM_DESKTOP_COLOR"));
            regen_background = TRUE;
        }
    }
    if(getenv ("RFM_DESKTOP_IMAGE") && strlen (getenv ("RFM_DESKTOP_IMAGE"))) {
        if(!desktop_bg_file || strcmp (desktop_bg_file, getenv ("RFM_DESKTOP_IMAGE"))) {
            DBG ("DESK: watch_root got RFM_DESKTOP_IMAGE=%s\n", getenv ("RFM_DESKTOP_IMAGE"));
            g_free (desktop_bg_file);
            desktop_bg_file = g_strdup (getenv ("RFM_DESKTOP_IMAGE"));
            regen_background = TRUE;
        }
    }

    if(regen_background) {
        if(view_p->background != None)
            XFreePixmap (GDK_DISPLAY (), view_p->background);
        view_p->background = None;
        if(desktop_bg_file && !g_file_test (desktop_bg_file, G_FILE_TEST_EXISTS)) {
            g_warning ("%s does not exist", desktop_bg_file);
        }
        if(rfm_population_try_read_lock (view_p)) {
            rodent_unselect_all_pixbuf (view_p);
#if 0
            population_t **tmp;
            for(tmp = view_p->population_pp; *tmp; tmp++) {
                population_t *population_p = *tmp;
                if(population_p->selected_pixbuf) {
                    g_object_unref (population_p->selected_pixbuf);
                    population_p->selected_pixbuf = rodent_make_selected_pixbuf (view_p, population_p);
                    if(population_p->en && population_p->en->st) {
                        memset (population_p->en->st, 0, sizeof (struct stat));
                    }
                }
            }
#endif
            rfm_population_read_unlock (view_p);
        }

        view_p->background = rfm_create_background_pixmap (desktop_bg_file);
        reload = TRUE;
    }

    /*XSetWindowBackgroundPixmap(GDK_DISPLAY(), GDK_WINDOW_XID(GTK_WIDGET(view_p->widgets.window)->window), root_pix);
       XClearWindow(GDK_DISPLAY(), GDK_WINDOW_XID(GTK_WIDGET(view_p->widgets.window)->window)); */

    if(reload) {
        DBG ("DESK: watch_root: reload_deskview\n");
        // just an expose is necesary.
        rodent_expose_all (view_p);
        DBG ("DESK: watch_root: rodent_expose_all done\n");
        return TRUE;
    }

    return TRUE;
}
