#ifndef RFM_RUN_H
# define RFM_RUN_H

/* The following two programs are the same thing, the only difference is that the
 * command line version will first create the argument array from the command
 * line and will run in a shell (allowing for redireccion, pipes and what not)
 * and the shell command will be saved in the lpterm history file.
 * */
/* run programs with command line: */
void
  rfm_thread_run (widgets_t * widgets_p, 
	  const gchar * command, gboolean interm);

/* run programs with argv array: */
void
  rfm_thread_run_argv (widgets_t * widgets_p, gchar ** argv, gboolean interm);

/* run programs with argv array and specify stdout_function: */
void
  rfm_thread_run_argv_with_stdout (
	  widgets_t * widgets_p, 
	  gchar ** argv, 
	  gboolean interm, 
	  void (*stdout_f) (void *stdout_data, 
			    void *stream, 
			    int childFD)
	  );

void
  rfm_thread_run2argv (widgets_t * widgets_p, 
	  const gchar * command, gboolean interm);

gpointer rfm_load_sh_command_history (gpointer data);

void
  rfm_save_sh_command_history (view_t * view_p, const gchar * command);

# if 0
       // this is not used, and DBH lock goes into eternal wait. why?

const
gchar *rfm_get_from_open_history (gchar * path2find, int *in_term);

# endif

void
  rfm_recover_flags (gchar * in_cmd, gboolean * interm, gboolean * hold);

void
  rfm_try_sudo (widgets_t * widgets_p, gchar ** argv, gboolean interm);

gchar *
  rfm_what_term (void);
#endif
