
static void
set_rows_columns (view_t * view_p, int width) {
    DBG (">>set_rows_columns width=%d CELLWIDTH=%d area=%d\n", width, CELLWIDTH, view_p->grid_area);
    int population_count;
    for(population_count = 0; view_p->population_pp && view_p->population_pp[population_count]; population_count++) ;

    view_p->grid_columns = width / CELLWIDTH;
    view_p->grid_rows = population_count / view_p->grid_columns;
    if(population_count % view_p->grid_columns)
        view_p->grid_rows++;
    DBG ("grid_rows =%d grid_columns =%d, width=%d population_count=%d\n",
         view_p->grid_rows, view_p->grid_columns, width, population_count);
    view_p->grid_rows = view_p->grid_area / view_p->grid_columns;
    if(view_p->grid_rows * view_p->grid_columns < view_p->max_elements) {
        TRACE ("++++adding an extra row...%d*%d < %d\n", view_p->grid_rows, view_p->grid_columns, view_p->max_elements);
        view_p->grid_rows++;
    }
}

static void
apply_window_size (view_t * view_p, int w, int h) {
    DBG (">> apply_window_size\n");
    /* this causes sporadic crashes.
     * is it really necessary?
     * let's put gdk_display_sync before gdk_flush
     * and see what happens... 
     * crashes just as well...
    gdk_display_sync (gdk_display_get_default ());
    gdk_flush ();*/
    
    rodent_on_size (view_p, w, h);

    view_p->paperY = view_p->grid_rows * CELLHEIGHT;

    TRACE
        ("graphics_apply_window_size:: gdk_window_resize(paperX,Y=%d,%d) grid_rows=%d, grid_cols=%d (%s)\n",
         view_p->paperX, view_p->paperY, view_p->grid_rows,
         view_p->grid_columns, ((view_p->en && view_p->en->path) ? view_p->en->path : "null"));

    gtk_widget_set_size_request (view_p->widgets.paper, view_p->paperX, view_p->paperY);

    DBG ("PAPER gtk_widget_set_size_request to %d, %d = %d\n",
         view_p->paperX, view_p->paperY, view_p->paperX * view_p->paperY);

    TRACE ("graphics_apply_window_size: scroll position=%lf\n",
           gtk_adjustment_get_value (gtk_scrolled_window_get_vadjustment (view_p->widgets.scrolled_window)));
    gdk_flush ();
    gdk_display_sync (gdk_display_get_default ());
    TRACE ("PAPER set to... w*h=area...%d x %d = %d\n",
           view_p->widgets.paper->allocation.width,
           view_p->widgets.paper->allocation.height,
           view_p->widgets.paper->allocation.width * view_p->widgets.paper->allocation.height);
    TRACE ("graphics_apply_window_size: graphics_apply_window_size:: done\n");
}


