
/*
 *
 * Edscott Wilson Garcia 2001-2005 for xfce project.
 *
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

static GHashTable *icon_hash = NULL;


static void
start_element (GMarkupParseContext * context,
               const gchar * element_name,
               const gchar ** attribute_names, const gchar ** attribute_values, gpointer user_data, GError ** error) {
    int i;
    gchar *name = NULL,
        *icon = NULL;
    /*DBG("start -> %s\n",element_name); */
    /* here we should have the type and icon attributes set,
     * but they are not :-(
     * */
    if(strcmp (element_name, "mime-type"))
        return;
    if(attribute_names) {
        for(i = 0; attribute_names[i]; i++)
            if(attribute_names[0] && attribute_values[0])
                name = g_strdup (attribute_values[0]);
        if(attribute_names[1] && attribute_values[1])
            icon = g_strdup (attribute_values[1]);
        if(name && icon) {
            g_hash_table_insert (icon_hash, name, (gpointer) icon);
            TRACE ("ICON: hashing %s=%s\n", name, icon);
        } else if(name) {
            TRACE ("ICON: no icon defined for %s\n", name);
            g_free (name);
        }

    }
    return;
}

static void
glib_parser (const gchar * mimefile) {
    FILE *f;
    size_t l;
    gchar line[81];
    GMarkupParseContext *context;
    GError *error = NULL;
    GMarkupParser parser = {
        start_element,
        NULL,
        NULL,                   /*text_fun, */
        NULL,
        NULL
    };
    gpointer user_data = NULL;

    DBG ("ICON: parsing %s\n", mimefile);
    context = g_markup_parse_context_new (&parser, 0, user_data, NULL);
    f = fopen (mimefile, "r");
    if(!f) {
        g_warning ("cannot open %s\n", mimefile);
        return;
    }
    while(!feof (f) && (l = fread (line, 1, 80, f)) != 0) {
        line[l] = 0;
        g_markup_parse_context_parse (context, line, l, &error);
    }
    fclose (f);

    g_markup_parse_context_free (context);
}

static int
create_icon_hash (const gchar * mimefile) {

    DBG ("ICON: create_icon_hash...\n");
    if(!mimefile) {
        g_warning ("create_icon_hash: mimefile cannot be NULL!");
        return 0;
    }

    if(!theme_info) {
        DBG ("ICON: creating new icon hash and factory for %s\n", theme_name);
        theme_info = (theme_info_t *) malloc (sizeof (theme_info_t));
        theme_info->icon_hash = icon_hash = g_hash_table_new (g_str_hash, g_str_equal);
    } else {
        icon_hash = theme_info->icon_hash;
        return 1;
    }

    glib_parser (mimefile);
    DBG ("ICON: theme_hash created for %s!\n", theme_name);
    return 1;
}

/**********************************************************************************************/
